LeetCode——TwoSum

题目:

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2 
我的解法:

public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int [] re=new int[2];
        int len=numbers.length;
        for(int i=0;i<len;i++){
            for(int j=i+1;j<len;j++){
                if(numbers[i]+numbers[j]==target){
                    re[0]=i+1;
                    re[1]=j+1;
                }
            }
        }
        return re;
    }
}
系统给出结果:

Time Limit Exceeded
显然系统无法忍受我时间复杂度为O(n^2)的时间复杂度。
在讨论版看到一个复杂度为O(n)的算法:

import java.util.Hashtable;
public class Solution {
    public int[] twoSum(int[] numbers, int target) {
        int [] re=new int[2];
        Hashtable<Integer,Integer> hashtable=new Hashtable<Integer,Integer>();
        int len=numbers.length;
        for(int i=0;i<len;i++){
            Integer n=hashtable.get(numbers[i]);
            if(n==null) hashtable.put(numbers[i],i);
            n=hashtable.get(target-numbers[i]);
            if(n!=null&&n<i){
                    re[0]=n+1;
                    re[1]=i+1;
                    return re;
            }
            
        }
        return re;
    }
}






原文地址:https://www.cnblogs.com/lcchuguo/p/5169541.html